#version 330 core

//vertex input
in vec2 fragmentUvs;
smooth in vec3 fragmentNormals;
in vec3 fragmentEyeDirection;
in vec3 fragmentLightDirection;
in vec3 fragmentWorldPosition;
//in uint fragmentMode;

//uniforms from main program
uniform sampler2D	colorTexture;
//uniform mat4	modelView;
uniform vec3	lightPosition;
uniform vec3	lightColor; //sunlight color might be a nice touch
uniform float	lightPower;
uniform float	material_shininess;
uniform int		mode;
//uniform uint mode; //0=3d world and lightning, 1=text (hud, start game and stuff), 3=normals
//in mat4 fragmentInverseModelView;

//pixelcolor
out vec4 color;


//forward declaration
vec4 celshade(in float intensity, in vec4 color);
vec3 celshade(in float intensity);

float intensityCel(in float intensity);

vec4 blur(in vec2 uv);

//TODO: make modules, length is getting ridiculous
void main()
{ 	
	if (mode == 0)
	{
		vec3 textureColor = texture2D( colorTexture, fragmentUvs ).rgb;
		float ambientCoeffiecient = 0.30;
		float shininess = 100.0;

		//differenc colors
		//low ambientcolor
		vec3 ambientColor = textureColor * ambientCoeffiecient;
		vec3 diffuseColor = textureColor;
		vec3 specularColor = lightColor;

		//daempfung fuer diffuseanteil, not yet implemented
		//float diffuseAttenuation = 0.8;

		//get directional components for shading
		vec3 n = normalize(fragmentNormals);
		vec3 l = normalize(fragmentLightDirection);
		vec3 e = normalize(fragmentEyeDirection);
		//vec3 r = reflect(-l,n);
		
		//angle between light and normal
		float diffuseIntensity = clamp( dot( n,l ), 0,1 );//max(dot(n,l), 0.0);
		//specularpart for total lighting
		vec3 spec = vec3(0);

		if (diffuseIntensity > 0.0) {
			vec3 h = normalize(l + e);
			float intSpec = max(dot(h,n), 0.0);

			//intSpec = intensityCel(intSpec);

			spec = specularColor * pow(intSpec, shininess);
		}
		
		//diffuseIntensity = intensityCel(diffuseIntensity);

		vec3 lightColor = diffuseIntensity * diffuseColor * lightColor * lightPower;	//diffusecolor
			//+ spec; //specular part
		
		//vec3 celShaded = celshade(0.08);
		//lightColor = lightColor * celshade(diffuseIntensity);

		color = vec4(
			max(lightColor
			+ spec
			, ambientColor//vec4(color3,1);
			//	, celshade(diffuseIntensity, color) 
			//, ambientColor * celShaded
			)
			, 1
		);

		color = vec4(lightColor + spec + ambientColor,1);	

		//color = blur(color);
	}
	
	if (mode == 1)
	{
		color = texture2D( colorTexture, fragmentUvs );
	}
	
	if (mode == 2)
	{
		color = vec4 (fragmentNormals,1);
		//normalsShader();
	}
	
}