#version 330 core

//for motion bluring:
//http://john-chapman-graphics.blogspot.co.at/2013/01/what-is-motion-blur-motion-pictures-are.html
//blogspot link with some source on how to code motionblur in a shader, with a motionvector
uniform mat4 inverseModelViewMat; // inverse model->view
uniform mat4 prevModelViewProj; // previous model->view->projection

uniform vec3 vViewRay;

uniform sampler2D uTexLinearDepth;

//blurs the color from the texture stuff, after rendering as a post process shading thing
vec4 blur(in vec2 uv){

	int numSamples = 4;
	float targetFPS = 60.0f;

	vec3 current = vViewRay * texture(uTexLinearDepth, uv).r;
	//current = inverseModelViewMat * current;

	// get previous screen space position:
	vec4 previous = prevModelViewProj * vec4(current, 1.0);
	previous.xyz /= previous.w;
	previous.xy = previous.xy * 0.5 + 0.5;
	vec2 blurVec = previous.xy - uv;

	return vec4(1);
}